// PartObject.h :  interface of class PartObject
//

#include <iostream>
#include <fstream>
#include <iomanip>
#include <string>
#include <cstdlib>
#include <cstring>
#include <math.h>
#include <stdio.h>

using namespace std;

typedef int* IntArrayPtr;
typedef double* DoubleArrayPtr;
typedef string* StringArrayPtr;
typedef class PartObject* PartArrayPtr;
typedef class SectionObject* SectionArrayPtr;

class PartObject
{
public:
	PartObject();
	PartObject(int size_SF, int size_ND);
	void setkPAT(int i, int iTYPE, string& partNAME);					// set kPAT,kTYPE,kpartNAME
	void setARRAY(IntArrayPtr tempNODE, IntArrayPtr tempSURFACE);		// set part_SF,part_ND
	void setCOLOR(int i, double& xRED, double& xGREEN, double& xBLUE);	// set COLOR
	int getkTYPE() {return kTYPE;}										// get kTYPE
	void setSECTION(int kind) {kindSECTION = kind;}						// set kindSECTION
	int getSECTION() {return kindSECTION;}								// get kindSECTION
	void DebugOUT(ofstream& debug, int debugOption);

	// printout PartObject-case in *.WRL with x3dOption = 0
	void printVRML(ofstream& outVRML, DoubleArrayPtr* coordinate, DoubleArrayPtr animationTIME, 
				   IntArrayPtr inversenodeID, int caseNUMBER, int NTIM, double vSCALE_N);
	// printout PartObject-case in *.X3D with x3dOption = 1
	void printXML(ofstream& outVRML, DoubleArrayPtr* coordinate, DoubleArrayPtr animationTIME, 
				  IntArrayPtr inversenodeID, int caseNUMBER, int NTIM, double vSCALE_N);
	~PartObject();
private:
	int kPAT;				// index of this part
	int kTYPE;				// element type composing this part (1:solid, 2:shell, 3:beam)
	string kpartNAME;		// name of this part
	int kindSECTION;		// flag for the existence of section including this part (1:exist)
	int number_SF;			// total number of surfaces composing this part
	int number_ND;			// total number of nodes composing this part
	IntArrayPtr* part_SF;	// integer array to store node-connectivity for surfaces
	IntArrayPtr part_ND;	// integer array to store node index for surfaces
};