// SectionObject.cpp :  implementation of class SectionObject

#include "stdafx.h"

#include "SectionObject.h"

using namespace std;

typedef int* IntArrayPtr;
typedef double* DoubleArrayPtr;
typedef string* StringArrayPtr;
typedef class PartObject* PartArrayPtr;
typedef class SectionObject* SectionArrayPtr;

SectionObject::SectionObject() :number_PT(10)
{
	section_PT = new int[number_PT];
}

SectionObject::SectionObject(int size_PT) :number_PT(size_PT)
{
	section_PT = new int[number_PT];
}

SectionObject::~SectionObject()
{
	delete section_PT;
}

// SectionObject::setkSEC set kSEC,ksectionNAME,ksecTextureRUL,ksecColor[3]
void SectionObject::setkSEC(int i, string& sectionNAME, string& textureURL, double color[])
{
	kSEC = i;
	ksectionNAME = sectionNAME;
	ksecTextureURL = textureURL;
	for (int j = 0; j < 3; j++) ksecColor[j] = color[j];
}

// SectionObject::setARRAY set array section_PT[]
void SectionObject::setARRAY(int j, int kPAT)
{
	section_PT[j] = kPAT;
}

// SectionObject::setCOLOR set color
void SectionObject::setCOLOR(int i, double& xRED, double& xGREEN, double& xBLUE)
{
	double rgb_K1[11] = { 1.0, 0.9, 0.8, 0.7, 0.6, 0.5, 0.4, 0.3, 0.2, 0.1, 0.0 };
	double rgb_K2[11] = { 1.0, 0.9, 0.8, 0.7, 0.6, 0.5, 0.4, 0.3, 0.2, 0.1, 0.0 };
	double rgb_K3[11] = { 1.0, 0.9, 0.8, 0.7, 0.6, 0.5, 0.4, 0.3, 0.2, 0.1, 0.0 };

	int order_ONE;
	int order_TWO;
	int order_THREE;

	order_ONE = i % 11;
	order_TWO =  ((i - order_ONE) / 11) % 11;
	order_THREE = (((i - order_ONE) / 11) - order_TWO) / 11;

	xRED = rgb_K1[order_ONE];
	xGREEN = rgb_K2[order_TWO];
	xBLUE = rgb_K3[order_THREE];

}

// SectionObject::printVRML printout in *.WRL
void SectionObject::printVRML(ofstream& outVRML, int caseNUMBER, int kPAT, int kTYPE)
{
	if (caseNUMBER == 1)
	{
	}
	else if (caseNUMBER == 2)
	{
	}
	else if (caseNUMBER == 3)
	{
		double xRED = 0.0, xGREEN = 0.0, xBLUE = 0.0;

		if (ksecTextureURL == "blank")
		{
			setCOLOR(kPAT, xRED, xGREEN, xBLUE);
		}
		else if (ksecTextureURL == "defaultSameColor")
		{
			setCOLOR(section_PT[0], xRED, xGREEN, xBLUE);
		}
		else if (ksecTextureURL == "givenSameColor")
		{
            xRED = ksecColor[0];
            xGREEN = ksecColor[1];
            xBLUE = ksecColor[2];
		}

		if ((ksecTextureURL == "blank") || (ksecTextureURL == "defaultSameColor") 
			                            || (ksecTextureURL == "givenSameColor"))
		{
			//# appearence Node - material Node# : color setting at material node
			outVRML << "			appearance Appearance {" << endl;
			outVRML << "				material Material {" << endl;
			if ((kTYPE == 1) || (kTYPE == 2)) // solid or shell element - face segment
			{
				outVRML << "					diffuseColor " << xRED << " " << xGREEN << " " << xBLUE << endl;
				outVRML << "					specularColor  0.5 0.5 0.5" << endl;
				outVRML << "					shininess 0.2" << endl;
				outVRML << "					emissiveColor 0 0 0" << endl;
				outVRML << "					transparency 0" << endl;
			}
			else if (kTYPE == 3)  //beam element - line segment
			{
				outVRML << "					emissiveColor " << xRED << " " << xGREEN << " " << xBLUE << endl;
			}
			outVRML << "				}" << endl;
			outVRML << "			}" << endl;
		}
		else
		{
			//# appearence Node - texture node# : imageTexture
			outVRML << "			appearance Appearance {" << endl;
			outVRML << "				material Material {" << endl;
			outVRML << "					emissiveColor 1.0 1.0 1.0"  << endl;
			outVRML << "					}" << endl;
			outVRML << "				texture ImageTexture {" << endl;
			outVRML << "					url \"" << ksecTextureURL << "\"" << endl;
			outVRML << "				}" << endl;
			outVRML << "			}" << endl;
		}
	}
	else if (caseNUMBER == 4)
	{
	}
	else if (caseNUMBER == 5)
	{
	}

}

// SectionObject::printXML printout in *.X3D
void SectionObject::printXML(ofstream& outVRML, int caseNUMBER, int kPAT, int kTYPE)
{
	if (caseNUMBER == 1)
	{
	}
	else if (caseNUMBER == 2)
	{
	}
	else if (caseNUMBER == 3)
	{
		double xRED = 0.0, xGREEN = 0.0, xBLUE = 0.0;

		if (ksecTextureURL == "ablank")
		{
			setCOLOR(kPAT, xRED, xGREEN, xBLUE);
		}
		else if (ksecTextureURL == "defaultSameColor")
		{
			setCOLOR(section_PT[0], xRED, xGREEN, xBLUE);
		}
		else if (ksecTextureURL == "givenSameColor")
		{
            xRED = ksecColor[0];
            xGREEN = ksecColor[1];
            xBLUE = ksecColor[2];
		}

		if ((ksecTextureURL == "blank") || (ksecTextureURL == "defaultSameColor") 
			                            || (ksecTextureURL == "givenSameColor"))
		{
			double xRED = 0.0, xGREEN = 0.0, xBLUE = 0.0;
			setCOLOR(kPAT, xRED, xGREEN, xBLUE);

			//# appearence Node # : color setting at material node
			outVRML << "              <Appearance >" << endl;
			if ((kTYPE == 1) || (kTYPE == 2)) // solid or shell element - face segment
			{
				outVRML << "                 <Material  "
						<< "transparency=\"0.0\" "
						<< "emissiveColor=\"0.0 0.0 0.0\" "
						<< "shininess=\"0.2\" "
					    << "diffuseColor=\"" << xRED << " " << xGREEN << " " << xBLUE <<"\""
						<< "specularColor=\"0.5 0.5 0.5\"/>" << endl;
			}
			else if (kTYPE == 3)  //beam element - line segment
			{
				outVRML << "                 <Material  "
						<< "emissiveColor=\"" << xRED << " " << xGREEN << " " << xBLUE << "\"" << endl;
			}
			outVRML << "              </Appearance>" << endl;
		}
		else
		{
			//# appearence Node - texture node# : imageTexture
			outVRML << "			appearance Appearance {" << endl;
			outVRML << "				material Material {" << endl;
			outVRML << "					emissiveColor 1.0 1.0 1.0"  << endl;
			outVRML << "					}" << endl;
			outVRML << "				texture ImageTexture {" << endl;
			outVRML << "					url \"" << ksecTextureURL << "\"" << endl;
			outVRML << "				}" << endl;
			outVRML << "			}" << endl;
		}
	}
	else if (caseNUMBER == 4)
	{
	}
	else if (caseNUMBER == 5)
	{
	}
}
